close all

% Build mesh from .geo file 
gmshOptions={'Mesh.Algorithm=4;','Mesh.CharacteristicLengthFactor=0.5;'};
%gmshOptions={};
meshfile=gmsh.buildmesh2d('condenser10',25,'force',true,'strings',gmshOptions,'check',true);%,'verbose',4);

Th=siMesh(meshfile);

tstart=tic();
figure(1);
Th.plot('legend',true)
set(legend(),'Location','NorthEastOutside')
axis off;axis image
T=toc(tstart);
title(sprintf('nq=%d, nme=%d, display in %.3f(s)',Th.nq,Th.get_nme(),T))

tstart=tic();
figure(2)
Th.plot('color',[0.85,0.85,0.85])
hold on
Th.plot('d',1,'Linewidth',2,'legend',true);
set(legend(),'Location','NorthEastOutside')
axis off;axis image
T=toc(tstart);
title(sprintf('nq=%d, nme=%d, display in %.3f(s)',Th.nq,Th.get_nme(),T))

fc_tools.graphics.DisplayFigures();